#!/usr/bin/perl

sub auto_recognize_platform() {
    my $platform='';
#Is this a Fedora Core distribution?
    if(-f "/etc/fedora-release" && -r "/etc/fedora-release") {
	open(IN,"/etc/fedora-release") or return '';
	my $line=<IN>;
	#Is this a Fedora Core release 2?
	if($line =~ /Fedora Core release 2/) {
	    $platform='fc2';
	}
	#Is this a Fedora Core release 3?
	if($line =~ /Fedora Core release 3/) {
	    $platform='fc3';
	}
	#Is this a Fedora Core release 4?
	if($line =~ /Fedora Core release 4/) {
	    $platform='fc4';
	}
	#Is this a Fedora Core release 5?
	if($line =~ /Fedora Core release 5/) {
	    $platform='fc5';
	}
	#Is this a Fedora Core release 6?
	if($line =~ /Fedora Core release 6/) {
	    $platform='fc6';
	}
	close IN;
    }
#Is this a Red Hat distribution?
    if(-f "/etc/redhat-release" && -r "/etc/redhat-release") {
	open(IN,"/etc/redhat-release") or return '';
	my $line=<IN>;
	#Is this a Red Hat 9?
	if($line =~ /Red Hat Linux release 9/) {
	    $platform='rh9';
	}
	
	close IN;
    }
    
#Is this a Suse distribution?
    if(-f "/etc/SuSE-release" && -r "/etc/SuSE-release") {
	open(IN,"/etc/SuSE-release") or return '';
	my $line=<IN>;
	#Is this a Suse 10.0?
	if($line =~ /SUSE LINUX 10\.0/) {
	    $platform='suse10';
	}
	
	close IN;
    }
#Is this a Mandrake distribution?
    if(-f "/etc/mandrake-release" && -r "/etc/mandrake-release") {
	open(IN,"/etc/mandrake-release") or return '';
	my $line=<IN>;
	#Is this a Mandrake 10.0?
	if($line =~ /Mandrake Linux release 10\.0/) {
	    $platform='mdk10';
	}
	
	close IN;
    }
#Is this a Mandriva distribution?
    if(-f "/etc/mandriva-release" && -r "/etc/mandriva-release") {
	open(IN,"/etc/mandriva-release") or return '';
	my $line=<IN>;
	#Is this a Mandriva 2006?
	if($line =~ /Mandriva Linux release 2006\.0/) {
	    $platform='mndr2006';
	}
	
	close IN;
    }
    if($platform eq '') {
	my $kversion=`uname -r`;
	$kversion =~ s/\n//g;
	
	if($kversion =~ /^\d+\.6/) {
	    $platform='generic26';
	} elsif($kversion =~ /^\d+\.4/) {
	    $platform='generic24';
	}
    }
    return $platform;
}

1;
