#!/usr/bin/perl

require "../functions.pl";

sub main() {
    my %specfiles=('fc2'=>'SPECFILE_FC2','fc3'=>'SPECFILE_FC3','fc4'=>'SPECFILE_FC4','fc5'=>'SPECFILE_FC5','fc6'=>'SPECFILE_FC6','rh9'=>'SPECFILE_RH9','suse10'=>'SPECFILE_SUSE10','mndr2006'=>'SPECFILE_MNDR2006','mdk10'=>'SPECFILE_MDK10');
    my %destpaths=('fc2'=>'/usr/src/redhat','fc3'=>'/usr/src/redhat','fc4'=>'/usr/src/redhat','fc5'=>'/usr/src/redhat','fc6'=>'/usr/src/redhat','rh9'=>'/usr/src/redhat','suse10'=>'/usr/src/packages','mndr2006'=>'/usr/src/RPM','mdk10'=>'/usr/src/RPM');
    my $platform=auto_recognize_platform();
    if($platform eq '') {
	print "Platform not supported. Cannot build\n";
	exit 1;
    }
    my $buildDir=$destpaths{$platform}."/BUILD";
    `./copysources $buildDir`;
    $?  && die "Cannot copy source files\n";
    my $specfile=$specfiles{$platform};
    `rpmbuild --target i386 -bb $specfile >rpmbuild-log 2>&1`;
    $?  && die "Errors in building. Consult rpmbuild-log for details\n";
    my $rpmFile=$destpaths{$platform}."/RPMS/i386/fxdriver-*";
    `cp $rpmFile ../rpms`;
    $? && die "Error copying final rpm file\n";
    `cp -R $buildDir/fxdriver-1.02/modules ..`;
    $? && die "Error copying final module\n";
    `rm -rf $buildDir/fxdriver-1.02`;
    $? && die "Error removing build directory\n";
    print "Build succeded\n";    
}

main();
