#!/usr/bin/perl
my $kversion=`uname -r`;
my $PWD=`pwd`;

$kversion =~ s/\n//g;
$PWD =~ s/\n//g;


my $buildPath="/lib/modules/$kversion/build";
my $model=$ARGV[0];

`mv -f Makefile_$model Makefile`;
`mv -f fxdriver.c $model.c`;


my $extraVersion=`grep "EXTRAVERSION = " $buildPath/Makefile`;
$extraVersion =~ s/\n//g;

if($extraVersion =~ /EXTRAVERSION = -(\d+)([a-zA-Z]*)/) {
    my $extra="EXTRAVERSION = -$1\n";
    open(IN,"$buildPath/Makefile") or die "Cannot open Makefile\n";
    open(OUT,">$buildPath/Makefile.new") or die "Cannot write Makefile\n";
    while(<IN>) {
	if(/EXTRAVERSION = /) {
	    print OUT $extra;
	} else {
	    print OUT $_;
	}
    }
    close OUT;
    close IN;
    unlink "$buildPath/Makefile" or die "Cannot substitute Makefile\n";
    rename "$buildPath/Makefile.new","$buildPath/Makefile" or die "Cannot substitute Makefile";
}

if(! -f "$buildPath/.config") {
    exit 10;
}

print "Make dep\n";
chdir "$buildPath";
`make dep`;
chdir "$PWD";

print "Finale Make\n";

$? && die "Cannot make dep\n";
`make -C $buildPath SUBDIRS=$PWD modules`;
$? && die "Errors in build\n"
