#!/bin/bash
KER_VER=`uname -r`
DRIVER_PATH="/lib/modules/$KER_VER/kernel/drivers/usb/misc/"
device="nfrd05"
major=180

if [ -d $DRIVER_PATH ]; then
	# Do nothing
	echo
else
	echo Driver Path does not exist , will create
	mkdir $DRIVER_PATH
fi

if [ -f $DRIVER_PATH/nfrd05rf.ko  ]; then
	echo $DRIVER_PATH"nfrd05rf.ko already exists"
	echo run uninstaller  to uninstall drive 
	exit 1
fi

if [ -f nfrd05rf.ko  -a  -f nfrd05rf.h  ]; then
	drvkernel=`/sbin/modinfo nfrd05rf.ko | grep vermagic | cut -f8 -d " "`
	# checking for kernel version with driver compiled version .
	if [ $drvkernel == $KER_VER ]; then
		#echo "copying ----- driver DUMMY  "
		cp -v nfrd05rf.ko $DRIVER_PATH
	else
		echo your kernel version $KER_VER does not match with NITGEN USB Driver compiled kernel verion  $drvkernel
		echo you can compile NITGEN USB eNBioScan-F driver source
		echo and  run this script or Get $KER_VER driver binary from vendor.
		exit 1
	fi
else
	echo "nfrd05rf.ko or nfrd05rf.h  file not found in current dir ....."
	exit 1;
fi

if [ -f /usr/include/linux/nfrd05rf.h ]; then
	echo "nfrd05rf.h already exists"
	exit 1
fi

cp -v nfrd05rf.h /usr/include/linux/


if [ -f /lib/nfrd05rf.so ]; then
	echo "nfrd05rf.so already exists"
	exit 1
fi

if [ -f nfrd05rf.so ]; then
	cp -v nfrd05rf.so /lib/
else
	echo "nfrd05rf.so not exist"
	exit 1
fi

if [ -f nfrd05rf.conf ]; then
	cp -f nfrd05rf.conf /etc/
else
	echo "nfrd05rf.conf not exist"
	exit 1
fi

#remove stale node
rm -f /dev/${device}[0-7]
#create 8 nodes for the device
mknod /dev/${device}0 c $major 238
mknod /dev/${device}1 c $major 239
mknod /dev/${device}2 c $major 240
mknod /dev/${device}3 c $major 241
mknod /dev/${device}4 c $major 242
mknod /dev/${device}5 c $major 243
mknod /dev/${device}6 c $major 244
mknod /dev/${device}7 c $major 245

#move  to driver detination directory
cd $DRIVER_PATH
#install the driver module into kernel
/sbin/insmod nfrd05rf.ko
# start hotplugging
#echo "starting hotplugging ......"
#/bin/sh /etc/init.d/hotplug start
echo "NITGEN USB eNBioScan-F Driver sucessfully installed "
echo "Disconnect the Device and Plug it back "
